#ifndef _NMDL_COMPILER_H_
#define _NMDL_COMPILER_H_

typedef enum tagNMDL_COMPILER_BOARD_TYPE {
	NMDL_COMPILER_BOARD_TYPE_MC12101,
	NMDL_COMPILER_BOARD_TYPE_MC12705
} NMDL_COMPILER_BOARD_TYPE;

typedef enum tagNMDL_COMPILER_RESULT {
	NMDL_COMPILER_RESULT_OK,
	NMDL_COMPILER_RESULT_MEMORY_ALLOCATION_ERROR,
	NMDL_COMPILER_RESULT_MODEL_LOADING_ERROR,
	NMDL_COMPILER_RESULT_INVALID_PARAMETER,
	NMDL_COMPILER_RESULT_INVALID_MODEL,
	NMDL_COMPILER_RESULT_UNSUPPORTED_OPERATION
} NMDL_COMPILER_RESULT;

#ifdef __cplusplus
extern "C" {
#endif

NMDL_COMPILER_RESULT NMDL_COMPILER_CompileONNX(
		unsigned int is_multi_unit,
		unsigned int board_type,
		const char* src_model,
		unsigned int src_model_size,
		float** dst_model,
		unsigned int* dst_model_floats
	);

NMDL_COMPILER_RESULT NMDL_COMPILER_CompileDarkNet(
		unsigned int is_multi_unit,
		unsigned int board_type,
		const char* src_model,
		unsigned int src_model_size,
		const char* src_weights,
		unsigned int src_weights_size,
		float** dst_model,
		unsigned int* dst_model_floats
	);

NMDL_COMPILER_RESULT NMDL_COMPILER_FreeModel(
		unsigned int board_type,
		float* dst_model
	);

const char *NMDL_COMPILER_GetLastError();

#ifdef __cplusplus
}
#endif

#endif
