/* /////////////////////////////////////////////////////////////////////////////
//
//                  RC MODULE PROPRIETARY INFORMATION
//     This software is supplied under the terms of a license agreement or
//     nondisclosure agreement with RC MODULE and may not be copied
//     or disclosed except in accordance with the terms of that agreement.
//          Copyright (c) 2019 RC MODULE. All Rights Reserved.
//
////////////////////////////////////////////////////////////////////////////////
*/

#ifndef _NMDL_IMAGE_CONVERTER_H_
#define _NMDL_IMAGE_CONVERTER_H_

typedef enum tagNMDL_IMAGE_CONVERTER_COLOR_FORMAT {
	NMDL_IMAGE_CONVERTER_COLOR_FORMAT_RGB,
	NMDL_IMAGE_CONVERTER_COLOR_FORMAT_RBG,
	NMDL_IMAGE_CONVERTER_COLOR_FORMAT_GRB,
	NMDL_IMAGE_CONVERTER_COLOR_FORMAT_GBR,
	NMDL_IMAGE_CONVERTER_COLOR_FORMAT_BRG,
	NMDL_IMAGE_CONVERTER_COLOR_FORMAT_BGR,
	NMDL_IMAGE_CONVERTER_COLOR_FORMAT_INTENSITY
} NMDL_IMAGE_CONVERTER_COLOR_FORMAT;

typedef enum tagNMDL_IMAGE_CONVERTER_BOARD_TYPE {
	NMDL_IMAGE_CONVERTER_BOARD_TYPE_MC12101,
	NMDL_IMAGE_CONVERTER_BOARD_TYPE_MC12705
} NMDL_IMAGE_CONVERTER_BOARD_TYPE;

#ifdef __cplusplus
extern "C" {
#endif

	int NMDL_IMAGE_CONVERTER_RequiredSize(
			unsigned int dst_width, 
			unsigned int dst_height, 
			unsigned int dst_color_format,
			unsigned int board_type
		);

	int	NMDL_IMAGE_CONVERTER_Convert(
			const char* src,
			float* dst,
			unsigned int src_size,
			unsigned int dst_width,
			unsigned int dst_height,
			unsigned int dst_color_format,
			const float rgb_divider[3],
			const float rgb_adder[3],
			unsigned int board_type
		);

#ifdef __cplusplus
}
#endif

#endif
